﻿using BlazorJavaScript.Models;
using System.Collections.Generic;
using System.Linq;


//====================================================
// Описание работы классов и методов исходника на:
// https://www.interestprograms.ru
// Исходные коды программ и игр
//====================================================


namespace BlazorJavaScript.Data
{
    public class DataRegions
    {
        public List<RegionItem> Regions { get; set; }
        private readonly string selectedColor;
        private readonly string defaultColor;


        public DataRegions(string _defaultColor, string _selectedColor)
        {
            defaultColor = _defaultColor;
            selectedColor = _selectedColor;

            Regions = new List<RegionItem>()
            {
                new RegionItem
                {
                    ISO = "AE",
                    Name = "United Arab Emirates",
                    Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "AF",
                    Name = "Afghanistan",
                    Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "AG",
                	Name = "Antigua and Barbuda",
                    Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "AL",
                	Name = "Albania",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "AM",
                	Name = "Armenia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "AO",
                	Name = "Angola",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "AR",
                	Name = "Argentina",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "AT",
                	Name = "Austria",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "AU",
                	Name = "Australia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "AZ",
                	Name = "Azerbaijan",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "BA",
                	Name = "Bosnia and Herzegovina",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "BB",
                	Name = "Barbados",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "BD",
                	Name = "Bangladesh",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "BE",
                	Name = "Belgium",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "BF",
                	Name = "Burkina Faso",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "BG",
                	Name = "Bulgaria",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "BI",
                	Name = "Burundi",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "BJ",
                	Name = "Benin",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "BN",
                	Name = "Brunei Darussalam",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "BO",
                	Name = "Bolivia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "BR",
                	Name = "Brazil",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "BS",
                	Name = "Bahamas",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "BT",
                	Name = "Bhutan",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "BW",
                	Name = "Botswana",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "BY",
                	Name = "Belarus",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "BZ",
                	Name = "Belize",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "CA",
                	Name = "Canada",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "CD",
                	Name = "Congo",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "CF",
                	Name = "Central African Republic",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "CG",
                	Name = "Congo",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "CH",
                	Name = "Switzerland",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "CI",
                	Name = "Cote d'Ivoire",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "CL",
                	Name = "Chile",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "CM",
                	Name = "Cameroon",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "CN",
                	Name = "China",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "CO",
                	Name = "Colombia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "CR",
                	Name = "Costa Rica",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "CU",
                	Name = "Cuba",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "CV",
                	Name = "Cape Verde",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "CY",
                	Name = "Cyprus",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "CZ",
                	Name = "Czech Republic",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "DE",
                	Name = "Germany",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "DJ",
                	Name = "Djibouti",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "DK",
                	Name = "Denmark",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "DM",
                	Name = "Dominica",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "DO",
                	Name = "Dominican Republic",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "DZ",
                	Name = "Algeria",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "EC",
                	Name = "Ecuador",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "EE",
                	Name = "Estonia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "EG",
                	Name = "Egypt",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "ER",
                	Name = "Eritrea",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "ES",
                	Name = "Spain",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "ET",
                	Name = "Ethiopia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "FI",
                	Name = "Finland",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "FJ",
                	Name = "Fiji",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "FK",
                	Name = "Falkland Islands",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "FR",
                	Name = "France",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "GA",
                	Name = "Gabon",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "GB",
                	Name = "United Kingdom",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "GD",
                	Name = "Grenada",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "GE",
                	Name = "Georgia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "GF",
                	Name = "French Guiana",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "GH",
                	Name = "Ghana",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "GL",
                	Name = "Greenland",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "GM",
                	Name = "Gambia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "GN",
                	Name = "Guinea",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "GQ",
                	Name = "Equatorial Guinea",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "GR",
                	Name = "Greece",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "GT",
                	Name = "Guatemala",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "GW",
                	Name = "Guinea - Bissau",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "GY",
                	Name = "Guyana",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "HN",
                	Name = "Honduras",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "HR",
                	Name = "Croatia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "HT",
                	Name = "Haiti",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "HU",
                	Name = "Hungary",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "ID",
                	Name = "Indonesia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "IE",
                	Name = "Ireland",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "IL",
                	Name = "Israel",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "IN",
                	Name = "India",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "IQ",
                	Name = "Iraq",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "IR",
                	Name = "Iran",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "IS",
                	Name = "Iceland",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "IT",
                	Name = "Italy",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "JM",
                	Name = "Jamaica",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "JO",
                	Name = "Jordan",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "JP",
                	Name = "Japan",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "KE",
                	Name = "Kenya",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "KG",
                	Name = "Kyrgyz Republic",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "KH",
                	Name = "Cambodia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "KM",
                	Name = "Comoros",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "KN",
                	Name = "Saint Kitts and Nevis",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "KP",
                	Name = "North Korea",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "KR",
                	Name = "South Korea",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "KW",
                	Name = "Kuwait",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "KZ",
                	Name = "Kazakhstan",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "LA",
                	Name = "Lao People's Democratic Republic",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "LB",
                	Name = "Lebanon",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "LC",
                	Name = "Saint Lucia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "LK",
                	Name = "Sri Lanka",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "LR",
                	Name = "Liberia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "LS",
                	Name = "Lesotho",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "LT",
                	Name = "Lithuania",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "LV",
                	Name = "Latvia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "LY",
                	Name = "Libya",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "MA",
                	Name = "Morocco",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "MD",
                	Name = "Moldova",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "MG",
                	Name = "Madagascar",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "MK",
                	Name = "Macedonia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "ML",
                	Name = "Mali",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "MM",
                	Name = "Myanmar",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "MN",
                	Name = "Mongolia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "MR",
                	Name = "Mauritania",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "MT",
                	Name = "Malta",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "MU",
                	Name = "Mauritius",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "MV",
                	Name = "Maldives",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "MW",
                	Name = "Malawi",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "MX",
                	Name = "Mexico",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "MY",
                	Name = "Malaysia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "MZ",
                	Name = "Mozambique",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "NA",
                	Name = "Namibia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "NC",
                	Name = "New Caledonia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "NE",
                	Name = "Niger",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "NG",
                	Name = "Nigeria",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "NI",
                	Name = "Nicaragua",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "NL",
                	Name = "Netherlands",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "NO",
                	Name = "Norway",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "NP",
                	Name = "Nepal",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "NZ",
                	Name = "New Zealand",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "OM",
                	Name = "Oman",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "PA",
                	Name = "Panama",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "PE",
                	Name = "Peru",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "PF",
                	Name = "French Polynesia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "PG",
                	Name = "Papua New Guinea",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "PH",
                	Name = "Philippines",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "PK",
                	Name = "Pakistan",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "PL",
                	Name = "Poland",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "PT",
                	Name = "Portugal",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "PY",
                	Name = "Paraguay",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "QA",
                	Name = "Qatar",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "RE",
                	Name = "Reunion",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "RO",
                	Name = "Romania",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "RS",
                	Name = "Serbia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "RU",
                	Name = "Russian Federation",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "RW",
                	Name = "Rwanda",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "SA",
                	Name = "Saudi Arabia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "SB",
                	Name = "Solomon Islands",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "SC",
                	Name = "Seychelles",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "SD",
                	Name = "Sudan",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "SE",
                	Name = "Sweden",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "SI",
                	Name = "Slovenia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "SK",
                	Name = "Slovakia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "SL",
                	Name = "Sierra Leone",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "SN",
                	Name = "Senegal",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "SO",
                	Name = "Somalia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "SR",
                	Name = "Suriname",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "ST",
                	Name = "Sao Tome and Principe",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "SV",
                	Name = "El Salvador",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "SY",
                	Name = "Syrian Arab Republic",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "SZ",
                	Name = "Swaziland",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "TD",
                	Name = "Chad",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "TG",
                	Name = "Togo",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "TH",
                	Name = "Thailand",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "TJ",
                	Name = "Tajikistan",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "TL",
                	Name = "Timor - Leste",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "TM",
                	Name = "Turkmenistan",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "TN",
                	Name = "Tunisia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "TR",
                	Name = "Turkey",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "TT",
                	Name = "Trinidad and Tobago",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "TW",
                	Name = "Taiwan",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "TZ",
                	Name = "Tanzania",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "UA",
                	Name = "Ukraine",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "UG",
                	Name = "Uganda",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "US",
                	Name = "United States of America",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "UY",
                	Name = "Uruguay",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "UZ",
                	Name = "Uzbekistan",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "VE",
                	Name = "Venezuela",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "VN",
                	Name = "Vietnam",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "VU",
                	Name = "Vanuatu",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "YE",
                	Name = "Yemen",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "ZA",
                	Name = "South Africa",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "ZM",
                	Name = "Zambia",
                	Color=defaultColor
                },
                new RegionItem
                {
                    ISO = "ZW",
                	Name = "Zimbabwe",
                	Color=defaultColor
                }
            };
        }



        public Dictionary<string, string> SelectRegions(string iso)
        {
            return new Dictionary<string, string>()
            {
                { Regions.First(n => n.ISO == iso).ISO, selectedColor }
            };
        }



        public void ResetSelect()
        {
            foreach (var i in Regions)
            {
                i.Color = defaultColor;
            }
        }

    }
}
